﻿Imports C1.Win.C1FlexGrid

Public Class Form1

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        _flexLeft.Rows.Count = 5
        For r As Integer = 1 To _flexLeft.Rows.Count - 1
            _flexLeft(r, 0) = "Left"
            _flexLeft(r, 1) = r
        Next
        _flexRight.Rows.Count = 5
        For r As Integer = 1 To _flexRight.Rows.Count - 1
            _flexRight(r, 0) = "Right"
            _flexRight(r, 1) = r
        Next

        ' both are OLE drag sources
        _flexLeft.DragMode = DragModeEnum.Manual
        _flexRight.DragMode = DragModeEnum.Manual

        ' both are OLE drop targets
        _flexLeft.DropMode = DropModeEnum.Manual
        _flexRight.DropMode = DropModeEnum.Manual

    End Sub

    Dim _src As C1FlexGrid = Nothing

    Private Sub _flex_BeforeMouseDown(sender As Object, e As BeforeMouseDownEventArgs) Handles _flexLeft.BeforeMouseDown, _flexRight.BeforeMouseDown
        ' start dragging when the user clicks the row headers
        Dim flex As C1FlexGrid = TryCast(sender, C1FlexGrid)
        Dim hti As HitTestInfo = flex.HitTest(e.X, e.Y)
        If hti.Type = HitTestTypeEnum.ColumnHeader Then
            ' select the row
            Dim index As Integer = hti.Column
            flex.[Select](1, index, flex.Rows.Count - 1, index, False)

            ' save info for target
            _src = flex

            ' do drag drop
            Dim dd As DragDropEffects = flex.DoDragDrop(flex.Clip, DragDropEffects.Move)

            ' if it worked, delete row from source (it's a move)
            If dd = DragDropEffects.Move Then
                flex.Cols.Remove(index)
            End If

            ' done, reset info
            _src = Nothing
        End If
    End Sub

    Private Sub _flex_DragOver(sender As Object, e As DragEventArgs) Handles _flexLeft.DragOver, _flexRight.DragOver
        ' check whether we can drop here:

        ' we must have a source object, and it should be the other grid
        ' (this sample allows dragging from one to the other grid only)
        If _src IsNot Nothing AndAlso Not _src.Equals(sender) Then
            ' check that we have the type of data we want
            If e.Data.GetDataPresent(GetType(String)) Then
                e.Effect = DragDropEffects.Move
            End If
        End If
    End Sub

    Private Sub _flex_DragDrop(sender As Object, e As DragEventArgs) Handles _flexLeft.DragDrop, _flexRight.DragDrop
        ' find the drop position
        Dim flex As C1FlexGrid = TryCast(sender, C1FlexGrid)
        Dim pt As Point = flex.PointToClient(New Point(e.X, e.Y))
        Dim hti As HitTestInfo = flex.HitTest(pt.X, pt.Y)
        Dim index As Integer = hti.Column
        If index < 0 Then
            index = flex.Cols.Count
        End If
        ' append
        If index < 1 Then
            index = 1
        End If
        ' after fixed row
        ' insert a new row at the drop position
        flex.Cols.Insert(index)

        ' copy data from source row
        flex.[Select](1, index, flex.Rows.Count - 1, index, False)
        flex.Clip = DirectCast(e.Data.GetData(GetType(String)), String)
    End Sub
End Class
